# generated automatically by aclocal 1.7.3 -*- Autoconf -*-

# Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002
# Free Software Foundation, Inc.
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.

#
# M4 macros for Kissme autoconfig
#

# This file is input to aclocal which generates aclocal.m4
# In turn, this an input to autoconf which generates ./configure


# Find the Java compiler.  In Kissme, we use it to  compiling the VM
# specific Java classes, and test harness code.
AC_DEFUN(KISSME_PATH_JAVAC,
[
  AC_ARG_VAR(JAVAC, [The chosen Java Compiler])
  AC_ARG_WITH(java_compiler,
  [  --with-java-compiler    select a bytecode compiler [default=jikes,gcj,javac]],
  [
    if test "x${withval}" != x ; then
      if test `basename "${withval}"` = "${withval}" ; then
	AC_PATH_PROG(JAVAC,${withval})
      else
	AC_CHECK_FILE(${withval}, 
		      [JAVAC=${withval} ;
		       AC_SUBST(JAVAC)])
      fi
      if test x${JAVAC} = x ; then
        AC_MSG_ERROR([Cannot find the selected Java compiler (${withval}).])
      fi
    fi
  ])
  if test x${JAVAC} = x ; then
    AC_PATH_PROGS(JAVAC,[jikes gcj kjc javac])
  fi
  if test x${JAVAC} = x ; then
    AC_MSG_ERROR([Cannot find a Java compiler.])
  fi
  _KISSME_IDENTIFY_JAVAC(${JAVAC})
])

# Identify a Java compiler, setting the relevant 'USE' variable.  At
# the moment, just guess from the basename.
AC_DEFUN(_KISSME_IDENTIFY_JAVAC, [
  if test x$3 = x ; then
    _MSG=
  else
    _MSG="$3 "
  fi
  AC_MSG_CHECKING([${_MSG}java compiler type])
  if test x$1 != x ; then
    _BASENAME=`basename $1` ; USE_JIKES=no ; USE_GCJ=no ; USE_SUN_JAVAC=no
    if test ${_BASENAME} = jikes ; then
      USE_JIKES$2=yes
      AC_MSG_RESULT(jikes)
    elif test ${_BASENAME} = gcj ; then
      USE_GCJ$2=yes
      AC_MSG_RESULT(gcj)
    elif test ${_BASENAME} = javac ; then
      USE_SUN_JAVAC$2=yes
      AC_MSG_RESULT(javac)
    else
      AC_MSG_RESULT(unknown)
    fi
    AC_SUBST(USE_JIKES$2)
    AC_SUBST(USE_GCJ$2)
    AC_SUBST(USE_SUN_JAVAC$2)
  fi
])


# Find the ZIP program
AC_DEFUN(KISSME_PATH_ZIP,
[
  AC_ARG_VAR(ZIP, [The chosen "zip" command])
  AC_PATH_PROG(ZIP,zip)
])



# Locate a Kissme Classpath build directory
AC_DEFUN(KISSME_PATH_KCP_DIR, [
  AC_ARG_WITH(kcp, 
  [  --with-kcp              select the Kissme Classpath directory],
  [
    if test "x${withval}" = x ; then
      AC_MSG_ERROR([No value supplied for --with-kcp.])
    fi
    AC_MSG_CHECKING([${withval}])
    _KISSME_TEST_CLASSPATH_DIR(${withval})
    if test x$KCP_DIR = x ; then
      AC_MSG_RESULT(no)
      AC_MSG_ERROR([Cannot find the selected Kissme Classpath directory (${withval}).])
    else
      AC_MSG_RESULT(yes)
    fi
  ],
  [
    if test x$KCP_DIR = x ; then
      _KISSME_FIND_CLASSPATH_DIR([kissme_classpath kissme-classpath ../kissme_classpath ../kissme-classpath ${HOME}/kissme_classpath ${HOME}/kissme-classpath ${HOME}/java/kissme_classpath ${HOME}/java/kissme-classpath])
    fi
  ])
  if test x$KCP_DIR != x ; then
    KCP_DIR=`(cd ${KCP_DIR}; pwd)`
    AC_SUBST(KCP_DIR)
    AC_SUBST(KCP,${KCP_DIR})
  fi
])

# Test a list of directories to see if they contain a Kissme Classpath build
AC_DEFUN(_KISSME_FIND_CLASSPATH_DIR, [
  AC_MSG_CHECKING([Kissme Classpath directory])
  for _F in $1 ; do
    _KISSME_TEST_CLASSPATH_DIR(${_F})
    if test x$_KCP_DIR != x ; then
      break
    fi
  done
  if test x${KCP_DIR} = x ; then
    AC_MSG_RESULT([not found])
  else
    AC_MSG_RESULT([${KCP_DIR}])
  fi
])

# Test a directory to see if it is a suitable Kissme Classpath directory.
# kcp_status will be set to depending on whether the
# directory already contains source code or (just) a binary distro.
AC_DEFUN(_KISSME_TEST_CLASSPATH_DIR, [
  if test -d $1 ; then
    KCP_DIR=$1
    if test -f $1/java/lang/Class.java && \
         test -f $1/gnu/classpath/Configuration.java && \
         test -f $1/kissme/vm/loaders/JarClassLoader.java ; then
      kcp_status=source
    elif test -f $1/java/lang/Class.class && \
       test -f $1/gnu/classpath/Configuration.class && \
       test -f $1/kissme/vm/loaders/JarClassLoader.class ; then
      kcp_status=binary
    else
      kcp_status=empty
    fi
  fi 
])


# Locate the GNU Classpath directory
AC_DEFUN(KISSME_PATH_GNU_CLASSPATH_DIR, [
  AC_ARG_WITH(gnu_classpath, 
  [  --with-gnu-classpath    select GNU Classpath source directory],
  [
    if test "x${withval}" = x ; then
      AC_MSG_ERROR([No value supplied for --with-gnu-classpath.])
    fi
    AC_MSG_CHECKING([${withval}])
    _KISSME_TEST_GNU_CLASSPATH_DIR(${withval})
    if test x$GNU_CLASSPATH_DIR = x ; then
      AC_MSG_RESULT(no)
      AC_MSG_ERROR([Cannot find the selected GNU Classpath source directory (${withval}).])
    else
      AC_MSG_RESULT(yes)
    fi
  ])
  if test x$GNU_CLASSPATH_DIR = x ; then
    _KISSME_FIND_GNU_CLASSPATH_DIR([classpath ../classpath ${HOME}/classpath ${HOME}/java/classpath])
  fi
  if test x$GNU_CLASSPATH_DIR != x ; then
    GNU_CLASSPATH_DIR=`(cd ${GNU_CLASSPATH_DIR}; pwd)`
    AC_SUBST(GNU_CLASSPATH_DIR)
  fi
])

# Test a list of directories to see if they are a GNU Classpath source
# directory
AC_DEFUN(_KISSME_FIND_GNU_CLASSPATH_DIR, [
  AC_MSG_CHECKING([GNU Classpath source directory])
  for _F in $1 ; do
    _KISSME_TEST_GNU_CLASSPATH_DIR(${_F})
    if test x$GNU_CLASSPATH_DIR != x ; then
      break
    fi
  done
  if test x$GNU_CLASSPATH_DIR = x ; then
    AC_MSG_RESULT([not found])
  else
    AC_MSG_RESULT([${GNU_CLASSPATH_DIR}])
  fi
])

# Test a directory to see if it is a GNU Classpath source directory
AC_DEFUN(_KISSME_TEST_GNU_CLASSPATH_DIR, [
  if test -f $1/java/lang/String.java && \
     test -f $1/gnu/classpath/Configuration.java.in && \
     test -f $1/lib/standard.omit ; then
    GNU_CLASSPATH_DIR=$1
  fi 
])


# Locate the GNU Classpath build directory
AC_DEFUN(KISSME_PATH_GNU_CLASSPATH_BUILD_DIR, [
  AC_ARG_WITH(gnu_classpath_build, 
  [  --with-gnu-classpath-build select GNU Classpath build directory],
  [
    if test "x${withval}" = x ; then
      AC_MSG_ERROR([No value supplied for --with-gnu-classpath-build.])
    fi
    AC_MSG_CHECKING([${withval}])
    _KISSME_TEST_GNU_CLASSPATH_BUILD_DIR(${withval})
    if test x$GNU_CLASSPATH_BUILD_DIR = x ; then
      AC_MSG_RESULT(no)
      AC_MSG_ERROR([Cannot find the selected GNU Classpath build directory (${withval}).])
    else
      AC_MSG_RESULT(yes)
    fi
  ])
  if test x$GNU_CLASSPATH_BUILD_DIR = x ; then
    _KISSME_FIND_GNU_CLASSPATH_BUILD_DIR([${GNU_CLASSPATH_DIR}  classpath ../classpath ${HOME}/classpath ${HOME}/java/classpath])
  fi
  if test x$GNU_CLASSPATH_BUILD_DIR != x ; then
    GNU_CLASSPATH_BUILD_DIR=`(cd ${GNU_CLASSPATH_BUILD_DIR}; pwd)`
    AC_SUBST(GNU_CLASSPATH_BUILD_DIR)
  fi
])

# Test a list of directories to see if they are a GNU Classpath buidl
# directory
AC_DEFUN(_KISSME_FIND_GNU_CLASSPATH_BUILD_DIR, [
  AC_MSG_CHECKING([GNU Classpath build directory])
  for _F in $1 ; do
    _KISSME_TEST_GNU_CLASSPATH_BUILD_DIR(${_F}/build)
    if test x$GNU_CLASSPATH_BUILD_DIR != x ; then
      break
    fi
    _KISSME_TEST_GNU_CLASSPATH_BUILD_DIR(${_F})
    if test x$GNU_CLASSPATH_BUILD_DIR != x ; then
      break
    fi
  done
  if test x$GNU_CLASSPATH_BUILD_DIR = x ; then
    AC_MSG_RESULT([not found])
  else
    AC_MSG_RESULT([${GNU_CLASSPATH_BUILD_DIR}])
  fi
])

# Test a directory to see if it is a GNU Classpath build directory
AC_DEFUN(_KISSME_TEST_GNU_CLASSPATH_BUILD_DIR, [
  if test -f $1/lib/java/lang/String.class && \
     test -f $1/lib/gnu/classpath/Configuration.class && \
     test -d $1/native/jni ; then
    GNU_CLASSPATH_BUILD_DIR=$1
  fi 
])


# Check that we can find or build the Java classes
AC_DEFUN(KISSME_CHECK_CLASS_BUILD_DEPENDENCIES, [
  AC_REQUIRE([KISSME_PATH_KCP_DIR])
  AC_REQUIRE([KISSME_PATH_GNU_CLASSPATH_DIR])
  AC_REQUIRE([KISSME_PATH_GNU_CLASSPATH_INSTALL_DIR])
  AC_REQUIRE([KISSME_CHECK_USE_KCP])
  if test x${KCP_DIR} = x ; then
    can_merge_kcp=no
    if test ${enable_use_kcp} = yes ; then
      AC_MSG_ERROR([Cannot find a Kissme-Classpath directory.])
    fi
    can_compile_kcp=no
  elif test x${GNU_CLASSPATH_DIR} = x ; then
    can_merge_kcp=no
    if test ${kcp_status} = empty ; then
      if test ${enable_use_kcp} = yes ; then
        AC_MSG_ERROR([Cannot populate the Kissme-Classpath source tree in ${KCP_DIR}: no GNU Classpath build directory could be found.])
      fi
      can_compile_kcp=no
    elif test ${kcp_status} = binary ; then
      if test ${enable_use_kcp} = yes ; then
        AC_MSG_NOTICE([you won't be able to "merge" a Kissme-Classpath source tree.])
      fi
      can_compile_kcp=no
    else
      can_compile_kcp=yes
    fi
  else
    if test ${kcp_status} = empty && \
       test ${enable_use_kcp} = yes ; then
      AC_MSG_NOTICE([the Kissme-Classpath directory (${KCP_DIR}) is currently empty: run "make merge-kcp" to build a source tree.])
    fi
    can_compile_kcp=yes
    can_merge_kcp=yes
  fi
  
  if test x${GLIBJ_ZIP} != x ; then
    have_glibj_zip=yes
  elif test ${enable_use_kcp} = no ; then
    AC_MSG_ERROR([Cannot find the GNU Classpath "glibj.zip" file which is needed to compile and build the Kissme "classes.zip" file.])
  else
    have_glibj_zip=no
  fi
])


# Set the classpaths for building and running Kissme

AC_DEFUN(KISSME_CLASSPATHS, [
  AC_REQUIRE([KISSME_PATH_KCP_DIR])
  AC_REQUIRE([KISSME_CHECK_CLASS_BUILD_DEPENDENCIES])
  AC_REQUIRE([KISSME_CHECK_USE_KCP])
  AC_REQUIRE([KISSME_CHECK_USE_ZIPS])
  ABS_HERE=`pwd`
  if test $enable_use_kcp = yes ; then
    if test $enable_use_zips = yes ; then
      KISSME_CLASSPATH=$ABS_HERE/kcp.zip
    else
      KISSME_CLASSPATH=$KCP_DIR
    fi
  else
    if test $enable_use_zips != yes ; then
      AC_MSG_ERROR([HUH!? Shouldn't get here])
    fi
    KISSME_BUILD_CLASSPATH=$ABS_HERE/classes:$GLIBJ_ZIP
    KISSME_CLASSPATH=$ABS_HERE/classes.zip:$GLIBJ_ZIP
    AC_SUBST(KISSME_BUILD_CLASSPATH)
  fi

  KCP_BUILD_CLASSPATH=$KCP_DIR
  AC_SUBST(KCP_BUILD_CLASSPATH)
  AC_SUBST(KISSME_CLASSPATH)
])


# Locate the (optional) directory containing the Mauve test suite
AC_DEFUN(KISSME_PATH_MAUVE_DIR, [
  AC_ARG_WITH(mauve, 
  [  --with-mauve            select optional Mauve (test harness) directory],
  [
    if test "x${withval}" = x ; then
      AC_MSG_ERROR([No value supplied for --with-mauve.])
    fi
    AC_MSG_CHECKING([${withval}])
    _KISSME_TEST_MAUVE_DIR(${withval})
    if test x$MAUVE_DIR = x ; then
      AC_MSG_RESULT(no)
      AC_MSG_ERROR([Cannot find the selected Mauve directory (${withval}).])
    else
      AC_MSG_RESULT(yes)
    fi
  ])
  if test x$MAUVE_DIR = x ; then
    _KISSME_FIND_MAUVE_DIR([mauve ../mauve ${HOME}/mauve ${HOME}/java/mauve])
  fi
  if test x$MAUVE_DIR != x ; then
    MAUVE_DIR=`(cd ${MAUVE_DIR}; pwd)`
  fi
  AC_SUBST(MAUVE_DIR)  
  AC_SUBST(MAUVE_CLASSPATH, ${MAUVE_DIR})
])

# Test a list of directories to see if they are a Mauve directory
AC_DEFUN(_KISSME_FIND_MAUVE_DIR, [
  AC_MSG_CHECKING([Mauve test harness])
  for _F in $1 ; do
    _KISSME_TEST_MAUVE_DIR(${_F})
    if test x$MAUVE_DIR != x ; then
      break
    fi
  done
  if test x$MAUVE_DIR = x ; then
    AC_MSG_RESULT([not found])
  else
    AC_MSG_RESULT([${MAUVE_DIR}])
  fi
])

# Test a directory to see if it is a GNU Classpath source / build directory
AC_DEFUN(_KISSME_TEST_MAUVE_DIR, [
  if test -f $1/gnu/testlet/SimpleTestHarness.java || \
     test -f $1/gnu/testlet/SimpleTestHarness.class ; then
    MAUVE_DIR=$1
  fi 
])



# Locate a Classpath installation directory
AC_DEFUN(KISSME_PATH_GNU_CLASSPATH_INSTALL_DIR, [
  AC_ARG_WITH(classpath_install_dir, 
  [  --with-classpath-install-dir select the GNU Classpath install directory],
  [
    if test "x${withval}" = x ; then
      AC_MSG_ERROR([No value supplied for --with-classpath-install-dir.])
    fi
    AC_MSG_CHECKING([${withval}])
    _KISSME_TEST_GNU_CLASSPATH_INSTALL_DIR(${withval})
    if test x$GNU_CLASSPATH_INSTALL_DIR = x ; then
      AC_MSG_RESULT(no)
      AC_MSG_ERROR([Cannot find the selected GNU Classpath installation.])
    else
      AC_MSG_RESULT(yes)
    fi
  ],
  [
    if test x$GNU_CLASSPATH_INSTALL_DIR = x ; then
      _KISSME_FIND_GNU_CLASSPATH_INSTALL_DIR([/usr/local/classpath /usr/local /usr /opt/classpath])
      if test x$GNU_CLASSPATH_INSTALL_DIR = x ; then
        AC_MSG_ERROR([Cannot find a GNU Classpath installation: install it and/or specify its location using --with-classpath-install-dir.])
      fi
    fi
  ])
  GNU_CLASSPATH_INSTALL_DIR=`(cd ${GNU_CLASSPATH_INSTALL_DIR}; pwd)`
  AC_SUBST(GNU_CLASSPATH_INSTALL_DIR)
  if test -r ${GNU_CLASSPATH_INSTALL_DIR}/share/classpath/glibj.zip ; then
    GLIBJ_ZIP=${GNU_CLASSPATH_INSTALL_DIR}/share/classpath/glibj.zip
    AC_SUBST(GLIBJ_ZIP)
  fi
])

# Test a list of directories to see if they contain a Classpath installation
AC_DEFUN(_KISSME_FIND_GNU_CLASSPATH_INSTALL_DIR, [
  AC_MSG_CHECKING([GNU Classpath installation directory])
  for _F in $1 ; do
    _KISSME_TEST_GNU_CLASSPATH_INSTALL_DIR(${_F})
    if test x$GNU_CLASSPATH_INSTALL_DIR != x ; then
      break
    fi
  done
  if test x${GNU_CLASSPATH_INSTALL_DIR} = x ; then
    AC_MSG_RESULT([not found])
  else
    AC_MSG_RESULT([${GNU_CLASSPATH_INSTALL_DIR}])
  fi
])

# Test a directory to see if it contains a Classpath installation.
AC_DEFUN(_KISSME_TEST_GNU_CLASSPATH_INSTALL_DIR, [
  if test -r $1/lib/classpath/libjavalang.so && \
     test -r $1/share/classpath/glibj.zip ; then
    GNU_CLASSPATH_INSTALL_DIR=$1
  fi 
])


# Find out if Kissme should boot from a ZIP file
AC_DEFUN(KISSME_CHECK_USE_ZIPS,
[
  AC_REQUIRE([KISSME_PATH_ZIP])
  AC_REQUIRE([KISSME_PATH_KCP_DIR])
  AC_ARG_ENABLE(use_zips, 
  [  --enable-use-zips       use ZIP file(s) for bootstrapping the VM])
  AC_MSG_CHECKING([whether to use ZIP files for bootstrapping the Kissme VM])
  if test x$enable_use_zips = xyes ; then
    if test x$ZIP = x ; then
      AC_MSG_RESULT(whoops)
      AC_MSG_ERROR([Cannot honour --enable-use-zips: cannot find a zip utility.]) 
    fi
  elif test x$enable_use_zips = xno ; then
    if test x$KCP_DIR = x ; then
      AC_MSG_RESULT(whoops)
      AC_MSG_ERROR([Cannot honour --disable-use-zips: cannot find a Kissme-Classpath directory.]) 
    fi
  else
    if test x$ZIP = x ; then
      enable_use_zips=no
    else
      enable_use_zips=yes
    fi
  fi
  AC_MSG_RESULT($enable_use_zips)
])


# Find out if Kissme should boot from a KCP assembly
AC_DEFUN(KISSME_CHECK_USE_KCP,
[
  AC_REQUIRE([KISSME_PATH_KCP_DIR])
  AC_REQUIRE([KISSME_CHECK_USE_ZIPS])
  AC_REQUIRE([KISSME_PATH_GNU_CLASSPATH_INSTALL_DIR])
  AC_ARG_ENABLE(use_kcp, 
  [  --enable-use-kcp        use a Kissme-Classpath for bootstrapping the VM])
  AC_MSG_CHECKING([whether to use Kissme-Classpath for bootstrapping the Kissme VM])
  if test x$enable_use_kcp = xyes ; then
    if test x$KCP_DIR = x ; then
      AC_MSG_RESULT(whoops)
      AC_MSG_ERROR([Cannot honour --enable-use-kcp: cannot find a Kissme-Classpath directory.]) 
    fi
  elif test x$enable_use_kcp = xno ; then
    if test x$GLIBJ_ZIP = x ; then
      AC_MSG_RESULT(whoops)
      AC_MSG_ERROR([Cannot honour --disable-use-kcp: cannot find "glibj.zip".]) 
    fi
  else
    if test x$GLIBJ_ZIP = x || \
       test x$enable_use_zips = xno ; then
      enable_use_kcp=yes
    else
      enable_use_kcp=no
    fi
  fi
  AC_MSG_RESULT($enable_use_kcp)
])

# Do all the work for Automake.                            -*- Autoconf -*-

# This macro actually does too much some checks are only needed if
# your package does certain things.  But this isn't really a big deal.

# Copyright 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003
# Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 9

# There are a few dirty hacks below to avoid letting `AC_PROG_CC' be
# written in clear, in which case automake, when reading aclocal.m4,
# will think it sees a *use*, and therefore will trigger all it's
# C support machinery.  Also note that it means that autoscan, seeing
# CC etc. in the Makefile, will ask for an AC_PROG_CC use...


AC_PREREQ([2.54])

# Autoconf 2.50 wants to disallow AM_ names.  We explicitly allow
# the ones we care about.
m4_pattern_allow([^AM_[A-Z]+FLAGS$])dnl

# AM_INIT_AUTOMAKE(PACKAGE, VERSION, [NO-DEFINE])
# AM_INIT_AUTOMAKE([OPTIONS])
# -----------------------------------------------
# The call with PACKAGE and VERSION arguments is the old style
# call (pre autoconf-2.50), which is being phased out.  PACKAGE
# and VERSION should now be passed to AC_INIT and removed from
# the call to AM_INIT_AUTOMAKE.
# We support both call styles for the transition.  After
# the next Automake release, Autoconf can make the AC_INIT
# arguments mandatory, and then we can depend on a new Autoconf
# release and drop the old call support.
AC_DEFUN([AM_INIT_AUTOMAKE],
[AC_REQUIRE([AM_SET_CURRENT_AUTOMAKE_VERSION])dnl
 AC_REQUIRE([AC_PROG_INSTALL])dnl
# test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" &&
   test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi

# test whether we have cygpath
if test -z "$CYGPATH_W"; then
  if (cygpath --version) >/dev/null 2>/dev/null; then
    CYGPATH_W='cygpath -w'
  else
    CYGPATH_W=echo
  fi
fi
AC_SUBST([CYGPATH_W])

# Define the identity of the package.
dnl Distinguish between old-style and new-style calls.
m4_ifval([$2],
[m4_ifval([$3], [_AM_SET_OPTION([no-define])])dnl
 AC_SUBST([PACKAGE], [$1])dnl
 AC_SUBST([VERSION], [$2])],
[_AM_SET_OPTIONS([$1])dnl
 AC_SUBST([PACKAGE], ['AC_PACKAGE_TARNAME'])dnl
 AC_SUBST([VERSION], ['AC_PACKAGE_VERSION'])])dnl

_AM_IF_OPTION([no-define],,
[AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
 AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package])])dnl

# Some tools Automake needs.
AC_REQUIRE([AM_SANITY_CHECK])dnl
AC_REQUIRE([AC_ARG_PROGRAM])dnl
AM_MISSING_PROG(ACLOCAL, aclocal-${am__api_version})
AM_MISSING_PROG(AUTOCONF, autoconf)
AM_MISSING_PROG(AUTOMAKE, automake-${am__api_version})
AM_MISSING_PROG(AUTOHEADER, autoheader)
AM_MISSING_PROG(MAKEINFO, makeinfo)
AM_MISSING_PROG(AMTAR, tar)
AM_PROG_INSTALL_SH
AM_PROG_INSTALL_STRIP
# We need awk for the "check" target.  The system "awk" is bad on
# some platforms.
AC_REQUIRE([AC_PROG_AWK])dnl
AC_REQUIRE([AC_PROG_MAKE_SET])dnl
AC_REQUIRE([AM_SET_LEADING_DOT])dnl

_AM_IF_OPTION([no-dependencies],,
[AC_PROVIDE_IFELSE([AC_PROG_CC],
                  [_AM_DEPENDENCIES(CC)],
                  [define([AC_PROG_CC],
                          defn([AC_PROG_CC])[_AM_DEPENDENCIES(CC)])])dnl
AC_PROVIDE_IFELSE([AC_PROG_CXX],
                  [_AM_DEPENDENCIES(CXX)],
                  [define([AC_PROG_CXX],
                          defn([AC_PROG_CXX])[_AM_DEPENDENCIES(CXX)])])dnl
])
])


# When config.status generates a header, we must update the stamp-h file.
# This file resides in the same directory as the config header
# that is generated.  The stamp files are numbered to have different names.

# Autoconf calls _AC_AM_CONFIG_HEADER_HOOK (when defined) in the
# loop where config.status creates the headers, so we can generate
# our stamp files there.
AC_DEFUN([_AC_AM_CONFIG_HEADER_HOOK],
[# Compute $1's index in $config_headers.
_am_stamp_count=1
for _am_header in $config_headers :; do
  case $_am_header in
    $1 | $1:* )
      break ;;
    * )
      _am_stamp_count=`expr $_am_stamp_count + 1` ;;
  esac
done
echo "timestamp for $1" >`AS_DIRNAME([$1])`/stamp-h[]$_am_stamp_count])

# Copyright 2002  Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA

# AM_AUTOMAKE_VERSION(VERSION)
# ----------------------------
# Automake X.Y traces this macro to ensure aclocal.m4 has been
# generated from the m4 files accompanying Automake X.Y.
AC_DEFUN([AM_AUTOMAKE_VERSION],[am__api_version="1.7"])

# AM_SET_CURRENT_AUTOMAKE_VERSION
# -------------------------------
# Call AM_AUTOMAKE_VERSION so it can be traced.
# This function is AC_REQUIREd by AC_INIT_AUTOMAKE.
AC_DEFUN([AM_SET_CURRENT_AUTOMAKE_VERSION],
	 [AM_AUTOMAKE_VERSION([1.7.3])])

# Helper functions for option handling.                    -*- Autoconf -*-

# Copyright 2001, 2002  Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 2

# _AM_MANGLE_OPTION(NAME)
# -----------------------
AC_DEFUN([_AM_MANGLE_OPTION],
[[_AM_OPTION_]m4_bpatsubst($1, [[^a-zA-Z0-9_]], [_])])

# _AM_SET_OPTION(NAME)
# ------------------------------
# Set option NAME.  Presently that only means defining a flag for this option.
AC_DEFUN([_AM_SET_OPTION],
[m4_define(_AM_MANGLE_OPTION([$1]), 1)])

# _AM_SET_OPTIONS(OPTIONS)
# ----------------------------------
# OPTIONS is a space-separated list of Automake options.
AC_DEFUN([_AM_SET_OPTIONS],
[AC_FOREACH([_AM_Option], [$1], [_AM_SET_OPTION(_AM_Option)])])

# _AM_IF_OPTION(OPTION, IF-SET, [IF-NOT-SET])
# -------------------------------------------
# Execute IF-SET if OPTION is set, IF-NOT-SET otherwise.
AC_DEFUN([_AM_IF_OPTION],
[m4_ifset(_AM_MANGLE_OPTION([$1]), [$2], [$3])])

#
# Check to make sure that the build environment is sane.
#

# Copyright 1996, 1997, 2000, 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 3

# AM_SANITY_CHECK
# ---------------
AC_DEFUN([AM_SANITY_CHECK],
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftest.file
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftest.file 2> /dev/null`
   if test "$[*]" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftest.file`
   fi
   rm -f conftest.file
   if test "$[*]" != "X $srcdir/configure conftest.file" \
      && test "$[*]" != "X conftest.file $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "$[2]" = conftest.file
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
AC_MSG_RESULT(yes)])

#  -*- Autoconf -*-


# Copyright 1997, 1999, 2000, 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 3

# AM_MISSING_PROG(NAME, PROGRAM)
# ------------------------------
AC_DEFUN([AM_MISSING_PROG],
[AC_REQUIRE([AM_MISSING_HAS_RUN])
$1=${$1-"${am_missing_run}$2"}
AC_SUBST($1)])


# AM_MISSING_HAS_RUN
# ------------------
# Define MISSING if not defined so far and test if it supports --run.
# If it does, set am_missing_run to use it, otherwise, to nothing.
AC_DEFUN([AM_MISSING_HAS_RUN],
[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
test x"${MISSING+set}" = xset || MISSING="\${SHELL} $am_aux_dir/missing"
# Use eval to expand $SHELL
if eval "$MISSING --run true"; then
  am_missing_run="$MISSING --run "
else
  am_missing_run=
  AC_MSG_WARN([`missing' script is too old or missing])
fi
])

# AM_AUX_DIR_EXPAND

# Copyright 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# For projects using AC_CONFIG_AUX_DIR([foo]), Autoconf sets
# $ac_aux_dir to `$srcdir/foo'.  In other projects, it is set to
# `$srcdir', `$srcdir/..', or `$srcdir/../..'.
#
# Of course, Automake must honor this variable whenever it calls a
# tool from the auxiliary directory.  The problem is that $srcdir (and
# therefore $ac_aux_dir as well) can be either absolute or relative,
# depending on how configure is run.  This is pretty annoying, since
# it makes $ac_aux_dir quite unusable in subdirectories: in the top
# source directory, any form will work fine, but in subdirectories a
# relative path needs to be adjusted first.
#
# $ac_aux_dir/missing
#    fails when called from a subdirectory if $ac_aux_dir is relative
# $top_srcdir/$ac_aux_dir/missing
#    fails if $ac_aux_dir is absolute,
#    fails when called from a subdirectory in a VPATH build with
#          a relative $ac_aux_dir
#
# The reason of the latter failure is that $top_srcdir and $ac_aux_dir
# are both prefixed by $srcdir.  In an in-source build this is usually
# harmless because $srcdir is `.', but things will broke when you
# start a VPATH build or use an absolute $srcdir.
#
# So we could use something similar to $top_srcdir/$ac_aux_dir/missing,
# iff we strip the leading $srcdir from $ac_aux_dir.  That would be:
#   am_aux_dir='\$(top_srcdir)/'`expr "$ac_aux_dir" : "$srcdir//*\(.*\)"`
# and then we would define $MISSING as
#   MISSING="\${SHELL} $am_aux_dir/missing"
# This will work as long as MISSING is not called from configure, because
# unfortunately $(top_srcdir) has no meaning in configure.
# However there are other variables, like CC, which are often used in
# configure, and could therefore not use this "fixed" $ac_aux_dir.
#
# Another solution, used here, is to always expand $ac_aux_dir to an
# absolute PATH.  The drawback is that using absolute paths prevent a
# configured tree to be moved without reconfiguration.

# Rely on autoconf to set up CDPATH properly.
AC_PREREQ([2.50])

AC_DEFUN([AM_AUX_DIR_EXPAND], [
# expand $ac_aux_dir to an absolute path
am_aux_dir=`cd $ac_aux_dir && pwd`
])

# AM_PROG_INSTALL_SH
# ------------------
# Define $install_sh.

# Copyright 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

AC_DEFUN([AM_PROG_INSTALL_SH],
[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
install_sh=${install_sh-"$am_aux_dir/install-sh"}
AC_SUBST(install_sh)])

# AM_PROG_INSTALL_STRIP

# Copyright 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# One issue with vendor `install' (even GNU) is that you can't
# specify the program used to strip binaries.  This is especially
# annoying in cross-compiling environments, where the build's strip
# is unlikely to handle the host's binaries.
# Fortunately install-sh will honor a STRIPPROG variable, so we
# always use install-sh in `make install-strip', and initialize
# STRIPPROG with the value of the STRIP variable (set by the user).
AC_DEFUN([AM_PROG_INSTALL_STRIP],
[AC_REQUIRE([AM_PROG_INSTALL_SH])dnl
# Installed binaries are usually stripped using `strip' when the user
# run `make install-strip'.  However `strip' might not be the right
# tool to use in cross-compilation environments, therefore Automake
# will honor the `STRIP' environment variable to overrule this program.
dnl Don't test for $cross_compiling = yes, because it might be `maybe'.
if test "$cross_compiling" != no; then
  AC_CHECK_TOOL([STRIP], [strip], :)
fi
INSTALL_STRIP_PROGRAM="\${SHELL} \$(install_sh) -c -s"
AC_SUBST([INSTALL_STRIP_PROGRAM])])

#                                                          -*- Autoconf -*-
# Copyright (C) 2003  Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 1

# Check whether the underlying file-system supports filenames
# with a leading dot.  For instance MS-DOS doesn't.
AC_DEFUN([AM_SET_LEADING_DOT],
[rm -rf .tst 2>/dev/null
mkdir .tst 2>/dev/null
if test -d .tst; then
  am__leading_dot=.
else
  am__leading_dot=_
fi
rmdir .tst 2>/dev/null
AC_SUBST([am__leading_dot])])

# serial 5						-*- Autoconf -*-

# Copyright (C) 1999, 2000, 2001, 2002, 2003  Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.


# There are a few dirty hacks below to avoid letting `AC_PROG_CC' be
# written in clear, in which case automake, when reading aclocal.m4,
# will think it sees a *use*, and therefore will trigger all it's
# C support machinery.  Also note that it means that autoscan, seeing
# CC etc. in the Makefile, will ask for an AC_PROG_CC use...



# _AM_DEPENDENCIES(NAME)
# ----------------------
# See how the compiler implements dependency checking.
# NAME is "CC", "CXX", "GCJ", or "OBJC".
# We try a few techniques and use that to set a single cache variable.
#
# We don't AC_REQUIRE the corresponding AC_PROG_CC since the latter was
# modified to invoke _AM_DEPENDENCIES(CC); we would have a circular
# dependency, and given that the user is not expected to run this macro,
# just rely on AC_PROG_CC.
AC_DEFUN([_AM_DEPENDENCIES],
[AC_REQUIRE([AM_SET_DEPDIR])dnl
AC_REQUIRE([AM_OUTPUT_DEPENDENCY_COMMANDS])dnl
AC_REQUIRE([AM_MAKE_INCLUDE])dnl
AC_REQUIRE([AM_DEP_TRACK])dnl

ifelse([$1], CC,   [depcc="$CC"   am_compiler_list=],
       [$1], CXX,  [depcc="$CXX"  am_compiler_list=],
       [$1], OBJC, [depcc="$OBJC" am_compiler_list='gcc3 gcc'],
       [$1], GCJ,  [depcc="$GCJ"  am_compiler_list='gcc3 gcc'],
                   [depcc="$$1"   am_compiler_list=])

AC_CACHE_CHECK([dependency style of $depcc],
               [am_cv_$1_dependencies_compiler_type],
[if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
  # We make a subdir and do the tests there.  Otherwise we can end up
  # making bogus files that we don't know about and never remove.  For
  # instance it was reported that on HP-UX the gcc test will end up
  # making a dummy file named `D' -- because `-MD' means `put the output
  # in D'.
  mkdir conftest.dir
  # Copy depcomp to subdir because otherwise we won't find it if we're
  # using a relative directory.
  cp "$am_depcomp" conftest.dir
  cd conftest.dir

  am_cv_$1_dependencies_compiler_type=none
  if test "$am_compiler_list" = ""; then
     am_compiler_list=`sed -n ['s/^#*\([a-zA-Z0-9]*\))$/\1/p'] < ./depcomp`
  fi
  for depmode in $am_compiler_list; do
    # We need to recreate these files for each test, as the compiler may
    # overwrite some of them when testing with obscure command lines.
    # This happens at least with the AIX C compiler.
    echo '#include "conftest.h"' > conftest.c
    echo 'int i;' > conftest.h
    echo "${am__include} ${am__quote}conftest.Po${am__quote}" > confmf

    case $depmode in
    nosideeffect)
      # after this tag, mechanisms are not by side-effect, so they'll
      # only be used when explicitly requested
      if test "x$enable_dependency_tracking" = xyes; then
	continue
      else
	break
      fi
      ;;
    none) break ;;
    esac
    # We check with `-c' and `-o' for the sake of the "dashmstdout"
    # mode.  It turns out that the SunPro C++ compiler does not properly
    # handle `-M -o', and we need to detect this.
    if depmode=$depmode \
       source=conftest.c object=conftest.o \
       depfile=conftest.Po tmpdepfile=conftest.TPo \
       $SHELL ./depcomp $depcc -c -o conftest.o conftest.c \
         >/dev/null 2>conftest.err &&
       grep conftest.h conftest.Po > /dev/null 2>&1 &&
       ${MAKE-make} -s -f confmf > /dev/null 2>&1; then
      # icc doesn't choke on unknown options, it will just issue warnings
      # (even with -Werror).  So we grep stderr for any message
      # that says an option was ignored.
      if grep 'ignoring option' conftest.err >/dev/null 2>&1; then :; else
        am_cv_$1_dependencies_compiler_type=$depmode
        break
      fi
    fi
  done

  cd ..
  rm -rf conftest.dir
else
  am_cv_$1_dependencies_compiler_type=none
fi
])
AC_SUBST([$1DEPMODE], [depmode=$am_cv_$1_dependencies_compiler_type])
AM_CONDITIONAL([am__fastdep$1], [
  test "x$enable_dependency_tracking" != xno \
  && test "$am_cv_$1_dependencies_compiler_type" = gcc3])
])


# AM_SET_DEPDIR
# -------------
# Choose a directory name for dependency files.
# This macro is AC_REQUIREd in _AM_DEPENDENCIES
AC_DEFUN([AM_SET_DEPDIR],
[AC_REQUIRE([AM_SET_LEADING_DOT])dnl
AC_SUBST([DEPDIR], ["${am__leading_dot}deps"])dnl
])


# AM_DEP_TRACK
# ------------
AC_DEFUN([AM_DEP_TRACK],
[AC_ARG_ENABLE(dependency-tracking,
[  --disable-dependency-tracking Speeds up one-time builds
  --enable-dependency-tracking  Do not reject slow dependency extractors])
if test "x$enable_dependency_tracking" != xno; then
  am_depcomp="$ac_aux_dir/depcomp"
  AMDEPBACKSLASH='\'
fi
AM_CONDITIONAL([AMDEP], [test "x$enable_dependency_tracking" != xno])
AC_SUBST([AMDEPBACKSLASH])
])

# Generate code to set up dependency tracking.   -*- Autoconf -*-

# Copyright 1999, 2000, 2001, 2002 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

#serial 2

# _AM_OUTPUT_DEPENDENCY_COMMANDS
# ------------------------------
AC_DEFUN([_AM_OUTPUT_DEPENDENCY_COMMANDS],
[for mf in $CONFIG_FILES; do
  # Strip MF so we end up with the name of the file.
  mf=`echo "$mf" | sed -e 's/:.*$//'`
  # Check whether this is an Automake generated Makefile or not.
  # We used to match only the files named `Makefile.in', but
  # some people rename them; so instead we look at the file content.
  # Grep'ing the first line is not enough: some people post-process
  # each Makefile.in and add a new line on top of each file to say so.
  # So let's grep whole file.
  if grep '^#.*generated by automake' $mf > /dev/null 2>&1; then
    dirpart=`AS_DIRNAME("$mf")`
  else
    continue
  fi
  grep '^DEP_FILES *= *[[^ @%:@]]' < "$mf" > /dev/null || continue
  # Extract the definition of DEP_FILES from the Makefile without
  # running `make'.
  DEPDIR=`sed -n -e '/^DEPDIR = / s///p' < "$mf"`
  test -z "$DEPDIR" && continue
  # When using ansi2knr, U may be empty or an underscore; expand it
  U=`sed -n -e '/^U = / s///p' < "$mf"`
  test -d "$dirpart/$DEPDIR" || mkdir "$dirpart/$DEPDIR"
  # We invoke sed twice because it is the simplest approach to
  # changing $(DEPDIR) to its actual value in the expansion.
  for file in `sed -n -e '
    /^DEP_FILES = .*\\\\$/ {
      s/^DEP_FILES = //
      :loop
	s/\\\\$//
	p
	n
	/\\\\$/ b loop
      p
    }
    /^DEP_FILES = / s/^DEP_FILES = //p' < "$mf" | \
       sed -e 's/\$(DEPDIR)/'"$DEPDIR"'/g' -e 's/\$U/'"$U"'/g'`; do
    # Make sure the directory exists.
    test -f "$dirpart/$file" && continue
    fdir=`AS_DIRNAME(["$file"])`
    AS_MKDIR_P([$dirpart/$fdir])
    # echo "creating $dirpart/$file"
    echo '# dummy' > "$dirpart/$file"
  done
done
])# _AM_OUTPUT_DEPENDENCY_COMMANDS


# AM_OUTPUT_DEPENDENCY_COMMANDS
# -----------------------------
# This macro should only be invoked once -- use via AC_REQUIRE.
#
# This code is only required when automatic dependency tracking
# is enabled.  FIXME.  This creates each `.P' file that we will
# need in order to bootstrap the dependency handling code.
AC_DEFUN([AM_OUTPUT_DEPENDENCY_COMMANDS],
[AC_CONFIG_COMMANDS([depfiles],
     [test x"$AMDEP_TRUE" != x"" || _AM_OUTPUT_DEPENDENCY_COMMANDS],
     [AMDEP_TRUE="$AMDEP_TRUE" ac_aux_dir="$ac_aux_dir"])
])

# Check to see how 'make' treats includes.	-*- Autoconf -*-

# Copyright (C) 2001, 2002 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 2

# AM_MAKE_INCLUDE()
# -----------------
# Check to see how make treats includes.
AC_DEFUN([AM_MAKE_INCLUDE],
[am_make=${MAKE-make}
cat > confinc << 'END'
doit:
	@echo done
END
# If we don't find an include directive, just comment out the code.
AC_MSG_CHECKING([for style of include used by $am_make])
am__include="#"
am__quote=
_am_result=none
# First try GNU make style include.
echo "include confinc" > confmf
# We grep out `Entering directory' and `Leaving directory'
# messages which can occur if `w' ends up in MAKEFLAGS.
# In particular we don't look at `^make:' because GNU make might
# be invoked under some other name (usually "gmake"), in which
# case it prints its new name instead of `make'.
if test "`$am_make -s -f confmf 2> /dev/null | grep -v 'ing directory'`" = "done"; then
   am__include=include
   am__quote=
   _am_result=GNU
fi
# Now try BSD make style include.
if test "$am__include" = "#"; then
   echo '.include "confinc"' > confmf
   if test "`$am_make -s -f confmf 2> /dev/null`" = "done"; then
      am__include=.include
      am__quote="\""
      _am_result=BSD
   fi
fi
AC_SUBST(am__include)
AC_SUBST(am__quote)
AC_MSG_RESULT($_am_result)
rm -f confinc confmf
])

# AM_CONDITIONAL                                              -*- Autoconf -*-

# Copyright 1997, 2000, 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

# serial 5

AC_PREREQ(2.52)

# AM_CONDITIONAL(NAME, SHELL-CONDITION)
# -------------------------------------
# Define a conditional.
AC_DEFUN([AM_CONDITIONAL],
[ifelse([$1], [TRUE],  [AC_FATAL([$0: invalid condition: $1])],
        [$1], [FALSE], [AC_FATAL([$0: invalid condition: $1])])dnl
AC_SUBST([$1_TRUE])
AC_SUBST([$1_FALSE])
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi
AC_CONFIG_COMMANDS_PRE(
[if test -z "${$1_TRUE}" && test -z "${$1_FALSE}"; then
  AC_MSG_ERROR([conditional "$1" was never defined.
Usually this means the macro was only invoked conditionally.])
fi])])

# Like AC_CONFIG_HEADER, but automatically create stamp file. -*- Autoconf -*-

# Copyright 1996, 1997, 2000, 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

AC_PREREQ([2.52])

# serial 6

# AM_CONFIG_HEADER is obsolete.  It has been replaced by AC_CONFIG_HEADERS.
AU_DEFUN([AM_CONFIG_HEADER], [AC_CONFIG_HEADERS($@)])

# serial 2

# AM_PROG_CC_C_O
# --------------
# Like AC_PROG_CC_C_O, but changed for automake.

# Copyright 1999, 2000, 2001 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

AC_DEFUN([AM_PROG_CC_C_O],
[AC_REQUIRE([AC_PROG_CC_C_O])dnl
AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
# FIXME: we rely on the cache variable name because
# there is no other way.
set dummy $CC
ac_cc=`echo $[2] | sed ['s/[^a-zA-Z0-9_]/_/g;s/^[0-9]/_/']`
if eval "test \"`echo '$ac_cv_prog_cc_'${ac_cc}_c_o`\" != yes"; then
   # Losing compiler, so override with the script.
   # FIXME: It is wrong to rewrite CC.
   # But if we don't then we get into trouble of one sort or another.
   # A longer-term fix would be to have automake use am__CC in this case,
   # and then we could set am__CC="\$(top_srcdir)/compile \$(CC)"
   CC="$am_aux_dir/compile $CC"
fi
])

