package hitme.basic.types;

/**
 * Testing the 'int' data type
 */
public class IntType extends hitme.HitMeTest {
    
  public static int callme(int a, int b)
  {
    if ((a + b) < 50) {
      return a + b;
    }
    else {
      return callme(a + b, b);
    }
  }
    
  public void workit()
  {
    int a, b, c, d, e, f, g, h;
	
    a = 2;
    b = 3;
    c = 4;
    d = 5;
    e = 6;
    f = 7;
    g = 8;
    h = 9;
	
    check(a == 2, "a != 2");    
    check(h == 9, "h != 9");
	
    a = b + c + d + e + f + g + h;
	
    check(a == 42, "a != 42");
	
    h = callme(d, e);
	
    check(h == 11, "h != 11");
	
    int[] mlarray = new int[22];
	
    mlarray[0] = a;
    mlarray[1] = b;
    mlarray[2] = c;
    mlarray[3] = d;
    mlarray[4] = e;
    
    f = mlarray[0];
    g = mlarray[1];
    h = mlarray[2];

    check(a == f, "a != f");
    check(b == g, "b != g");
    check(c == h, "c != h");
    
    int divop1 = 22;
    int divop2 = 3;
    
    int res = divop1 / divop2;
    int mod = divop1 % divop2;
    
    check(res == 7, "/ failed");
    check(mod == 1, "% failed");
    
    int count = 0;
    int bigint = 0x1000000;
    while (bigint != 0) {
      bigint /= 0x10;
      count += 1;
    }
    check(count == 7, "/= failed");

    count = 0;
    bigint = 1;
    while (bigint != 0x1000000) {
      bigint *= 2;
      count += 1;
    }
    check(count == 24, "*= failed");

    try {
      int one = 1;
      int zero = 0;
      int infinity = one / zero;
      check(false, "no divide by zero exception");
    } catch (ArithmeticException ex) { /* */ }
  }

  public String describe() {
    return "'int' test";
  }
  
  public void test() 
  {    
    workit();
    workit();
  }
}
