#ifndef __RUNTIME_H__
#define __RUNTIME_H__

void java_lang_Runtime_exitInternal(JNIEnv* env, jint value);

jstring java_lang_Runtime_getLibraryPath(JNIEnv* env, jclass class);

jobject java_lang_Runtime_execInternal(JNIEnv* env, jobject obj, 
				       jarray arglist, jarray environment,
				       jobject directory);

jobject java_lang_Runtime_nativeGetLibname(JNIEnv* env, jobject obj,
					   jobject pathname, jobject filename);
jint java_lang_Runtime_nativeLoad(JNIEnv* env, jobject obj, jobject filename);
jobject java_lang_Runtime_initializeLinkerInternal(JNIEnv* env, jobject obj);

void java_lang_Runtime_gc(JNIEnv* env, jobject obj);

void java_lang_Runtime_runFinalizersOnExitInternal(JNIEnv* env, jobject obj, 
						   jboolean val);
void java_lang_Runtime_runFinalization(JNIEnv* env, jobject obj);

jlong java_lang_Runtime_freeMemory(JNIEnv* env, jobject object);
jlong java_lang_Runtime_totalMemory(JNIEnv* env, jobject object);

void java_lang_Runtime_insertSystemProperties(JNIEnv* env, jobject prop);

#endif
