/*
 * @doc MODULE
 * @module natives.h |
 *
 * This file contains one prototype - for the function that initialises the
 * native methods in a class.
 *
 */

#ifndef __NATIVES_H__
#define __NATIVES_H__

#include "vm/classfil.h"

typedef struct 
{ 
  char* pszClassName;    /* @field Class in which the method is declared */ 
  char* pszMethodName;   /* @field The method's name */ 
  char* pszMethodSig;    /* @field The method's signature */ 
  void* pFunction;       /* @field Function pointer to the native method */ 
} tNewNativeLookup; 

void NATIVES_InitNatives(tClassLoaderTuple* pstClass, int32 isSafe);

#endif
