#ifndef __STRUCT_TCLASSLOADER_H__
#define __STRUCT_TCLASSLOADER_H__

/*
 * @doc TYPE
 * @struct
 * This structure contains <class structure, class loader> pair.
 */

struct tclassloadertuple
{
#ifdef DEBUG_OBJECT_FOR_GC
  int32 magic1;
#endif
  Uid uidName;                    /* the fully qualified class name */
  struct tobject** classLoader;   /* the class loader object that loaded
				     this class */
  struct tobject** classObject;   /* the java.lang.Class object for 
				     this class */
  struct tobject** vmClassObject; /* the java.lang.VMClass object for 
				     this class */
  struct tclass* pstClass;        /* the internal JVM class structure 
				     (but without the static fields) */
  int32* pi32StatVars;            /* @field Pointer to space for static 
				     fields */
#ifdef DEBUG_OBJECT_FOR_GC
  int32 magic2;
#endif  
};

#endif
