/*
 * @doc TYPE
 * @struct
 * All the information needed about a method is stored in one of these
 * structures.
 *
 */

struct tmethod
{
  #ifdef CLASSPERSIST
  PID pid;
  #endif
  uint16 u16AccessFlags; /* @field Access flags for the method */
  Uid uidName;           /* @field Pointer to method's name */
  Uid uidSignature;      /* @field Pointer to method's signature */
  tCode* pstCode;        /* @field Pointer to code structure */
  tClassLoaderTuple* pstClass;      /* @field Pointer back to the class it's defined in */
  uint16 u16VTIndex;     /* @field Method's virtual table index */
  uint16 u16ArgSize;     /* @field Size of arguments in 32-bit words */
  uint16 u16RetSize;     /* @field Size of return type in 32-bit words */

  //Jewel 15/06/2000
  uint16 u16NumExceptions; /* Number of (checked) exceptions that can be thrown by this method */
  tClassLoaderTuple** pstExceptions;  /* Array of types of exceptions thrown by this method */
  byte bHaveResolvedExceptions;
};
